%
% Construccin de un Modelo Tridimensional para Representacion de Campos de Viento
%

clear;
hold off;
format long;


%Vectores de movimiento%

u=[0 0 1 1 0 0 1 1];
v=[0 1 1 0 0 1 1 0];
w=[0 0 0 0 1 1 1 1];

CUBO=0;
PUNTO=1;
ARISTA=1;


%ENTRADA DE DATOS%

fprintf(1,'Modelo de Viento 3D.\n');


%Introduccion de datos%

fprintf(1,'Introduzca la longitud maxima en el eje x\n');
ejex = input(' ');
fprintf(1,'Introduzca la longitud maxima en el eje y\n');
ejey = input(' ');
fprintf(1,'Introduzca la longitud maxima en el eje z\n');
ejez = input(' ');

fprintf(1,'Introduzca el numero de puntos en la direccion x\n');
NumPuntosx = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion y\n');
NumPuntosy = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion z\n');
NumPuntosz = input(' ');

NUMz=NumPuntosz-1;
NUMy=NumPuntosy-1;
NUMx=NumPuntosx-1;
deltaX=1/NUMx;
deltaY=1/NUMy;
deltaZ=1/NUMz;


%Geometria del terreno

fprintf(1,'Introduzca la funcion del terreno en funcion de las variables x e y\n');
zs = input('','s');
fzs = inline(char(zs),'x','y');

fprintf(1,'Introduzca la derivada parcial de la funcion del terreno respecto de x\n');
Zsx = input('','s');
fZsx = inline(char(Zsx),'x','y');

fprintf(1,'Introduzca la derivada parcial de la funcion del terreno respecto de y\n');
Zsy = input('','s');
fZsy = inline(char(Zsy),'x','y');



%Bucle de generacion de hexaedros%

for k=1:NUMz
    
    Z0=(k-1)*deltaZ;
    
	for j=1:NUMy
		Y0=(j-1)*deltaY;
		
		for i=1:NUMx
			X0=(i-1)*deltaX;
			CUBO=CUBO+1;

			for r=1:8
			C(r)=0;
			end;

			for h=1:8
				
				X=X0+u(h)*deltaX;
				Y=Y0+v(h)*deltaY;
				Z=Z0+w(h)*deltaZ;
				
				EXISTEnodo=0;
				p=1;

				while p<PUNTO & EXISTEnodo==0

					if coordX(p)==X & coordY(p)==Y & coordZ(p)==Z
						
						EXISTEnodo=1;
						NUMnodo=p;
					else
						
						p=p+1;
					end;
				end;
				
				if EXISTEnodo==1
					C(h)=NUMnodo;
				else
					coordX(PUNTO)=X;
					coordY(PUNTO)=Y;
					coordZ(PUNTO)=Z;
					C(h)=PUNTO;
					PUNTO=PUNTO+1;
				end;
			end;

               
            for q=1:8
                
                D(CUBO,q)=C(q);
                
            end;
            
%Creacin de aristas

			for COLUMNAarista=1:12
				
				pos1=COLUMNAarista;
				pos2=COLUMNAarista+1;
				
				if pos2==5
					pos2=1;
				end;
				
				if pos2==9
					pos2=5;
				end;
				
				if COLUMNAarista>8
					pos1=COLUMNAarista-8;
					pos2=pos1+4;
				end;
                    
                    a=double(C(pos1));
                    b=double(C(pos2));
                    
				if a > b
					auxiliar=pos1;
					pos1=pos2;
					pos2=auxiliar;
				end;
                
                a=C(pos1);
                b=C(pos2);

				EXISTEarista=0;
				s=1;
				
				while s<ARISTA & EXISTEarista==0

					if B(1,s)==C(pos1) & B(2,s)==C(pos2)

						EXISTEarista=1;
						NUMarista=s;
					else
						s=s+1;
					end;
				end;
				
				if EXISTEarista==1
					A(CUBO,COLUMNAarista)=NUMarista;
					
				else
					A(CUBO,COLUMNAarista)=ARISTA;
					B(1,ARISTA)=C(pos1);
                    B(2,ARISTA)=C(pos2);
                    
                    UNO=subs(a);
                    DOS=subs(b);
                    
                    %Dibujar cada arista en el momento que se crea%
                    DibujarX(1)=coordX(UNO);
                    DibujarX(2)=coordX(DOS);
                    DibujarY(1)=coordY(UNO);
                    DibujarY(2)=coordY(DOS);
                    DibujarZ(1)=coordZ(UNO);
                    DibujarZ(2)=coordZ(DOS);
                   
                    plot3(DibujarX,DibujarY,DibujarZ);
                    hold on;
                                       
					ARISTA=ARISTA+1;
				end;
			end;

		end;
	end;
end;

 

%Introduccion de los datos para el viento interpolado

fprintf('A continuacion introducimos las constantes para generar la funcion de viento interpolado de la forma v=k*(h/Z0)^0.1 \n');
fprintf('Introduzca el valor de Kx\n');
Kx=input('');
fprintf('Introduzca el valor de Ky\n');
Ky=input('');
fprintf('Introduzca el valor de Z0\n');
Z0=input('');

 

%Ordenamos los datos obtenidos de la generacion de la malla

%Coordenada X

 for I = 1 : (PUNTO-2)
     interc = I;
     for b = (I+1) : (PUNTO-1)
         if coordX(b) < coordX(interc)
             interc = b;
         end
     end
     temp = coordX(I);
     coordX(I) = coordX(interc);
     coordX(interc) = temp;
 end
 
 cont=1;
 k=coordX(cont);
 coX(cont)=k;
 
 for f = (cont+1) : (PUNTO-1)
     k=coordX(f);
     if k ~= coX(cont)
         cont=cont+1;
         coX(cont)=k;
     end
 end
 
 g=NumPuntosx;
 l=1;
 cont=1;
 f=1;
 
 while f < PUNTO-1
     t=1;
     while t <= l
         if cont == (g+1)
             cont=1;
         end
         coordX(f)=coX(cont);
         f=f+1;
         t=t+1;
     end
     cont=cont+1;
 end
 
     
 
%Coordenada Y

 for I = 1 : (PUNTO-2)
     interc = I;
     for b = (I+1) : (PUNTO-1)
         if coordY(b) < coordY(interc)
             interc = b;
         end
     end
     temp = coordY(I);
     coordY(I) = coordY(interc);
     coordY(interc) = temp;
 end
 
 cont=1;
 k=coordY(cont);
 coY(cont)=k;
 
 for f = (cont+1) : (PUNTO-1)
     k=coordY(f);
     if k ~= coY(cont)
         cont=cont+1;
         coY(cont)=k;
     end
 end
 
 g=NumPuntosy;
 l=NumPuntosx;
 cont=1;
 f=1;
 
 while f < PUNTO-1
     t=1;
     while t <= l
         if cont == (g+1)
             cont=1;
         end
         coordY(f)=coY(cont);
         f=f+1;
         t=t+1;
     end
     cont=cont+1;
 end
 
 
 
 %Coordenada Z

 for I = 1 : (PUNTO-2)
     interc = I;
     for b = (I+1) : (PUNTO-1)
         if coordZ(b) < coordZ(interc)
             interc = b;
         end 
     end
     temp = coordZ(I);
     coordZ(I) = coordZ(interc);
     coordZ(interc) = temp;
 end
 
 cont=1;
 k=coordZ(cont);
 coZ(cont)=k;
 
 for f = (cont+1) : (PUNTO-1)
     k=coordZ(f);
     if k ~= coZ(cont)
         cont=cont+1;
         coZ(cont)=k;
     end
 end
 
 g=NumPuntosz;
 l=NumPuntosx*NumPuntosy;
 cont=1;
 f=1;
 
 while f < PUNTO-1
     t=1;
     while t <= l
         if cont == (g+1)
             cont=1;
         end
         coordZ(f)=coZ(cont);
         f=f+1;
         t=t+1;
     end
     cont=cont+1;
 end
 
  
 
 %Situamos cada punto en suelo(1), paredes(2) e interior(0)

 m=NumPuntosx;
 n=NumPuntosy;
 p=NumPuntosz;
 
NR=zeros(1,m*n*p);
 
for i = 1 : m*n*p
        
    if coordX(i)==0 | coordX(i)==1 | coordY(i)==0 | coordY(i)==1 | coordZ(i)==1
            NR(i)=2;         
    else
        if coordZ(i)==0     
             NR(i)=1;
         end
    end
end


%Cambio de variable

 coX = zeros(m*n*p,1);
 coY = zeros(m*n*p,1);
 coZ = zeros(m*n*p,1);
 h=zeros(m*n*p,1);
 for I = 1 : (m*n*p)
     coX(I) = coordX(I)*ejex;
     coY(I) = coordY(I)*ejey;
     coZ(I) = (ejez-fzs(coX(I),coY(I)))*coordZ(I)+fzs(coX(I),coY(I));
 end
 

%Generamos el viento interpolado

for I=1:m*n*p
    h(I)=coZ(I)-fzs(coX(I),coY(I));
    if h <= 0
        vx(I)=0;
        vy(I)=0;
    else
        vx(I)=Kx*(h(I)/Z0)^.1;
        vy(I)=Ky*(h(I)/Z0)^.1;
    end
end
 


%Sistema de ecuaciones

fprintf('Introduzca el valor de alpha 1  \n');
alpha1=input('');
fprintf('Introduzca el valor de alpha \n');
alpha=input('');


%Puntos interiores

cont=0;
A=zeros(m*n*p,1);
AI=zeros(m*n*p,1);
AJ=zeros(m*n*p,1);
B=zeros(m*n*p,1);

for i = 1 : m*n*p
    
    if NR(i)==0
        
        B(i)=-2*(alpha1)^2*((100*((m-1)/ejex)*(vx(i+1)-vx(i-1))/2)+(((n-1)/ejey)*(vy(i+m)-vy(i-m))/2));
        
        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i;
        A(cont)=-2*((m-1)/ejex)^2-2*((n-1)/ejey)^2-2*alpha^2*((p-1)/ejez)^2;
        
        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i-1;
        A(cont)=((m-1)/ejex)^2;

        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i+1;
        A(cont)=((m-1)/ejex)^2;

        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i-m;
        A(cont)=((n-1)/ejey)^2;

        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i+m;
        A(cont)=((n-1)/ejey)^2;

        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i-m*n;
        A(cont)=alpha^2*((p-1)/ejez)^2;

        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i+m*n;
        A(cont)=alpha^2*((p-1)/ejez)^2;
  
    end  
    
        if NR(i)==1          
            
            n1 =  fZsx(coX(i),coY(i)) / (((fZsx(coX(i),coY(i)))^2+(fZsy(coX(i),coY(i)))^2+1)^0.5);
            n2 =  fZsy(coX(i),coY(i)) / (((fZsx(coX(i),coY(i)))^2+(fZsy(coX(i),coY(i)))^2+1)^0.5);
            n3 = -1 / (((fZsx(coX(i),coY(i)))^2+(fZsy(coX(i),coY(i)))^2+1)^0.5);
            
            B(i) = -2*alpha1^2*(n1*vx(i)+n2*vy(i));
                             
        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i;
        A(cont)=-3*alpha^2*n3*(p-1)/(2*ejez);
        
       cont=cont+1;
       AI(cont)=i;
       AJ(cont)=i-1;
       A(cont)=-n1*(m-1)/(2*ejex);

       cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i+1;
        A(cont)=n1*(m-1)/(2*ejex);

        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i-m;
        A(cont)=-n2*(n-1)/(2*ejey);

        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i+m;
        A(cont)=n2*(n-1)/(2*ejey);

        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i+m*n; 
        A(cont)=4*alpha^2*n3*(p-1)/(2*ejez);

        cont=cont+1;
        AI(cont)=i;
        AJ(cont)=i+2*m*n; 
        A(cont)=-n3*alpha^2*(p-1)/(2*ejez);

    end
        
    if NR(i)==2
        cont=cont+1;
        B(i)=0;
        AI(cont)=i;
        AJ(cont)=i;
        A(cont)=1;
        
    end
    
end


sol=zeros(m*n*p,1);
S=sparse(AI,AJ,A);
[L,U]=lu(S);
sol = bicgstab(S,B,1e-6,m*n*p,L,U);
%sol = bicgstab(S,B,1e-8);



%Obtenemos el vector viento en cada punto a partir de los resultados del
%sistema de ecuaciones

NNR=zeros(1,m*n*p);

for i = 1 : m*n*p
    
    if ( h(i)==0 & coX(i)==0 ) | ( h(i)==0 & coX(i)==ejex ) | ( h(i)==0 & coY(i)==0 ) | ( h(i)==0 & coY(i)==ejey )
            NNR(i)=8;
    else
        if ((coX(i) == 0 & coY(i) == 0) | (coX(i) == 0 & coY(i) == ejey) | (coX(I) == ejex & coY == 0) | (coX == ejex & coY == ejey))
            NNR(i) = 5;
        else
            if coX(i) == 0
                NNR(i) = 1;
            else
                if coX(i) == ejex
                    NNR(i) = 2;
                else
                    if coY(i) == 0
                        NNR(i) = 3;
                    else
                        if coY(i) == ejey
                            NNR(i) = 4;
                        else
                            if h(i) == 0
                                NNR(i) = 6;
                            else
                                if coZ(i) == ejez
                                    NNR(i) = 7;
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end

alpha2 = alpha1/alpha;


%Obtencion del viento final

for i = 1 : m*n*p
    if NNR(i) == 0
        wx(i) = vx(i) + (1/(2*alpha1^2))*((m-1)*(sol(i+1)-sol(i-1))/(2*ejex));
        wy(i) = vy(i) + (1/(2*alpha1^2))*((n-1)*(sol(i+m)-sol(i-m))/(2*ejey));
        wz(i) = (1/(2*alpha2^2))*((p-1)*(sol(i+m*n)-sol(i-m*n))/(2*ejez));
        w(i) = (wx(i)^2+wy(i)^2+wz(i)^2)^0.5;
    else
        if NNR(i) == 1
            wx(i) = vx(i) + (1/(2*alpha1^2))*((m-1)*(-sol(i+2)+4*sol(i+1)-3*sol(i))/(2*ejex));
            wy(i) = vy(i);
            wz(i) = 0;
            w(i) = (wx(i)^2+wy(i)^2+wz(i)^2)^0.5;    
        else
            if NNR(i) == 2
                wx(i) = vx(i) + (1/(2*alpha1^2))*((m-1)*(sol(i-2)-4*sol(i-1)+3*sol(i))/(2*ejex));
                wy(i) = vy(i);
                wz(i) = 0;
                w(i) = (wx(i)^2+wy(i)^2+wz(i)^2)^0.5;
            else
                if NNR(i) == 3
                    wx(i) = vx(i);
                    wy(i) = vy(i) + (1/(2*alpha1^2))*((n-1)*(-sol(i+2*m)+4*sol(i+m)-3*sol(i))/(2*ejey));
                    wz(i) = 0;
                    w(i) = (wx(i)^2+wy(i)^2+wz(i)^2)^0.5;
                else
                    if NNR(i) == 4
                        wx(i) = vx(i);
                        wy(i) = vy(i) + (1/(2*alpha1^2))*((n-1)*(sol(i-2*m)-4*sol(i-m)+3*sol(i))/(2*ejey));
                        wz(i) = 0;
                        w(i) = (wx(i)^2+wy(i)^2+wz(i)^2)^0.5;    
                    else
                        if NNR(i) == 5
                            wx(i) = vx(i);
                            wy(i) = vy(i);
                            wz(i) = 0;
                            w(i) = (wx(i)^2+wy(i)^2+wz(i)^2)^0.5;
                        else
                            if NNR(i) == 6
                                wx(i) = vx(i) + (1/(2*alpha1^2))*((m-1)*(sol(i+1)-sol(i-1))/(2*ejex));
                                wy(i) = vy(i) + (1/(2*alpha1^2))*((n-1)*(sol(i+m)-sol(i-m))/(2*ejey));
                                wz(i) = (1/(2*alpha2^2))*((p-1)*(-sol(i+2*m*n)+4*sol(i+m*n)-3*sol(i))/(2*ejez));
                                w(i) = (wx(i)^2+wy(i)^2+wz(i)^2)^0.5;    
                            else
                                if NNR(i) == 7
                                    wx(i) = vx(i);
                                    wy(i) = vy(i);
                                    wz(i) = (1/(2*alpha2^2))*((p-1)*(sol(i-2*m*n)-4*sol(i-m*n)+3*sol(i))/(2*ejez));
                                    w(i) = (wx(i)^2+wy(i)^2+wz(i)^2)^0.5;
                                else
                                    if NNR(i) == 8
                                        wx(i) = vx(i);
                                        wy(i) = vy(i);
                                        wz(i) = 0;
                                        w(i) = (wx(i)^2+wy(i)^2+wz(i)^2)^0.5;
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end


%Representacion grafica
  
 xt = zeros(1,m);
 yt = zeros(1,n);
 zt = zeros(m,n);
 
incx=ejex/(m-1);
incy=ejey/(n-1);
 
 for i = 1 : m
 xt(i) = incx*(i-1);    
 end
 
 for j = 1 : n
 yt(j) = incy*(j-1);    
 end
 
 for j = 1 : n
     for i = 1 : m
     zt(i,j) = fzs(xt(i),yt(j));    
     end
 end
 
quiver3(coX,coY,coZ,wx',wy',wz');
 
hold on
surf(xt,yt,zt');
hold off
